/* 
 * Leaflet Generic JSON Layer v0.1.0 - 2014-01-09 
 * 
 * Copyright 2014 Stefano Cudini 
 * stefano.cudini@gmail.com 
 * http://labs.easyblog.it/ 
 * 
 * Licensed under the MIT license. 
 * 
 * Demo: 
 * http://labs.easyblog.it/maps/leaflet-layerjson/ 
 * 
 * Source: 
 * git@github.com:stefanocudini/leaflet-layerJSON.git 
 * 
 */
(function(){L.LayerJSON=L.FeatureGroup.extend({includes:L.Mixin.Events,options:{url:"search.php?lat1={minlat}&lat2={maxlat}&lon1={minlon}&lon2={maxlon}",jsonpParam:null,callData:null,propertyLoc:"loc",propertyTitle:"title",filter:null,dataToMarker:null,onEachMarker:null,layerTarget:null,buildPopup:null,optsPopup:null,buildIcon:null,minShift:8e3,updateOutBounds:!0,precision:6,attribution:""},initialize:function(a){L.FeatureGroup.prototype.initialize.call(this,[]),L.Util.setOptions(this,a),this._dataToMarker=this.options.dataToMarker||this._defaultDataToMarker,this._buildIcon=this.options.buildIcon||this._defaultBuildIcon,this._filterMarker=this.options.filter||function(){return!0},this._dataRequest=null,this._dataUrl=this.options.url,this._center=null,this._maxBounds=null,this._markers={},this.options.jsonpParam?(this._dataUrl+="&"+this.options.jsonpParam+"=",this._callData=this.getJsonp):this._callData=this.options.callData||this.getAjax},onAdd:function(a){L.FeatureGroup.prototype.onAdd.call(this,a),this._center=a.getCenter(),this._maxBounds=a.getBounds(),a.on("moveend",this._onMove,this),this.update()},onRemove:function(a){a.off("moveend",this._onMove,this),L.FeatureGroup.prototype.onRemove.call(this,a);for(var b in this._layers)this._layers.hasOwnProperty(b)&&L.FeatureGroup.prototype.removeLayer.call(this,this._layers[b])},getAttribution:function(){return this.options.attribution},addLayer:function(a){return this.options.layerTarget?(this.options.layerTarget.addLayer.call(this.options.layerTarget,a),this.fire("layeradd",{layer:a})):(L.FeatureGroup.prototype.addLayer.call(this,a),this)},removeLayer:function(a){return this.options.layerTarget?(this.options.layerTarget.removeLayer.call(this.options.layerTarget,a),this.fire("layerremove",{layer:a})):(L.FeatureGroup.prototype.removeLayer.call(this,a),this)},clearLayers:function(){return this.options.layerTarget?this.options.layerTarget.clearLayers.call(this.options.layerTarget):L.FeatureGroup.prototype.clearLayers.call(this),this},_defaultBuildIcon:function(){return new L.Icon.Default},_defaultDataToMarker:function(a,b){var c=a[this.options.propertyTitle],d=L.Util.extend({icon:this._buildIcon(a,c),title:c},a),e=new L.Marker(b,d);return this.options.buildPopup&&e.bindPopup(this.options.buildPopup(a,e),this.options.optsPopup),e},addMarker:function(a){var b,c,d=this.options.propertyLoc;b=L.Util.isArray(d)?L.latLng(parseFloat(a[d[0]]),parseFloat(a[d[1]])):L.latLng(a[d]),c=[b.lat,b.lng].join()+a[this.options.propertyTitle],this._markers[c]||(this._markers[c]=this._dataToMarker(a,b)),this.options.onEachMarker&&this.options.onEachMarker(a,this._markers[c]),this.addLayer(this._markers[c])},_updateMarkersCached:function(a){for(var b in this._markers)a.contains(this._markers[b].getLatLng())?this.addLayer(this._markers[b]):this.removeLayer(this._markers[b])},_onMove:function(){var a=this._map.getCenter(),b=this._map.getBounds();return this.options.minShift&&this._center.distanceTo(a)<this.options.minShift?!1:(this._center=a,this.options.updateOutBounds&&this._maxBounds.contains(b)?(this._updateMarkersCached(b),!1):(this._maxBounds.extend(b),this.update(),void 0))},update:function(){var a=this._map.getBounds(),b=a.getSouthWest(),c=a.getNorthEast(),d=this.options.precision,e=L.Util.template(this._dataUrl,{minlat:b.lat.toFixed(d),maxlat:c.lat.toFixed(d),minlon:b.lng.toFixed(d),maxlon:c.lng.toFixed(d)});this._dataRequest&&this._dataRequest.abort();var f=this;f.fire("dataloading",{url:e}),this._dataRequest=this._callData(e,function(a){f._dataRequest=null,f.fire("dataloaded",{data:a});for(var b in a)f._filterMarker(a[b])&&f.addMarker.call(f,a[b])})},getAjax:function(url,cb){void 0===window.XMLHttpRequest&&(window.XMLHttpRequest=function(){try{return new ActiveXObject("Microsoft.XMLHTTP.6.0")}catch(a){try{return new ActiveXObject("Microsoft.XMLHTTP.3.0")}catch(b){throw new Error("XMLHttpRequest is not supported")}}});var request=new XMLHttpRequest;return request.open("GET",url),request.onreadystatechange=function(){var response={};if(4===request.readyState&&200===request.status){try{response=window.JSON?JSON.parse(request.responseText):eval("("+request.responseText+")")}catch(err){console.info(err),response={}}cb(response)}},request.send(),request},getJsonp:function(a,b){var c=document.getElementsByTagName("body")[0],d=L.DomUtil.create("script","layerjson-jsonp",c);return L.LayerJSON.callJsonp=function(a){b(a),c.removeChild(d)},d.type="text/javascript",d.src=a+"L.LayerJSON.callJsonp",{abort:function(){d.parentNode.removeChild(d)}}}})}).call(this);